
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>XNA游戏开发之2D游戏 / iVAN</title>

    <meta name="description" content="XNA游戏开发之2D游戏 摘要:以XNA为基础的游戏可以利用3D模型为游戏加入动画效果,也可以利用简单的程序技巧将2维图片显示成动画.虽然2维动画相对3维动画来说简单一些,但是制作出来的游戏其趣味性和挑战性也绝不逊色.今天我们就一块学习一下在使用XNA Framework开发2D游戏时的一些基础知识和注意事项. 主要内容: 1.2D游戏动画的基本原理 2.动画素材的准备 3.一个简单的2D动画 一.2D游戏动画的基本原理 在XNA中制作2D动画的过程很像翻卡通小人书,首先绘制好各种角色造型,然后以固定的时间间隔来显示不同">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">XNA游戏开发之2D游戏</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>摘要：以XNA为基础的游戏可以利用3D模型为游戏加入动画效果，也可以利用简单的程序技巧将2维图片显示成动画。虽然2维动画相对3维动画来说简单一些，但是制作出来的游戏其趣味性和挑战性也绝不逊色。今天我们就一块学习一下在使用XNA Framework开发2D游戏时的一些基础知识和注意事项。</p>
<p><strong>主要内容：</strong></p>
<p>1.2D游戏动画的基本原理</p>
<p>2.动画素材的准备</p>
<p>3.一个简单的2D动画</p>
<h3>一、2D游戏动画的基本原理</h3>
<p>在XNA中制作2D动画的过程很像翻卡通小人书，首先绘制好各种角色造型，然后以固定的时间间隔来显示不同的图片，当时间间隔小到一定程度时人眼就难以区分，从而形成一种动画效果。如果做过flash或者使用fireworks做过gif的朋友可能更容易理解，它就像flash中的逐帧动画一样，每帧显示一个图片，然后连起来就形成了动画效果。由于在XNA中有SpriteBatch可以绘制图片精灵，这样一来我们只需事先做好不同的角色造型的图片，每次在执行Update方法的时候改变绘制的精灵图片就可以制作出动画效果。</p>
<h3>二、动画素材的准备</h3>
<p>XNA开发2D动画的原理比较容易理解，我也就不过多的赘余了，现在我们就开始准备游戏素材。XNA的SpriteBatch的绘制方法有点类似于样式表CSS的background属性，可以通过设置参数来显示一个图片的其中一部分，这样一来我们为了方便管理游戏角色就只需要将同一角色的不同造型放到同一张图片中，每次更新时显示图片的不同部分就可以了。例如下面这幅图片就是如此：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvNzZ5MmRxLmJheS5saXZlZmlsZXN0b3JlLmNvbS95MXBqZm5JWjBFUGF3NFFhaWd0aDc3ZjAyWlNJcGpmeHVYUWRxLVJRM3JfNFlfdmFPNEpNNS16cjZWWXpJa05WRUNxcVUyM2llYVJ5UmxKek10RzY4V01BeDlfb0dKa0Q2MDYvc3ByaXRlUGljLnBuZz9wc2lkPTE=.jpg"></p>
<p>在这幅图片中我们将22个不同造型的角色放到同一幅图片中，事先规划好每个小图片的大小，保证各个图片连接起来播放时能够形成一组连贯的动作。当然，为了让整个效果看起来更生动一些我们再来准备一张背景图片：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvNzZ5MmRxLmJheS5saXZlZmlsZXN0b3JlLmNvbS95MXBJUDNMVTcwSjlwYzhSOHBycFp3bTBMUE1MZEFmcC1LTG1fMXhPSktHNDd0d1hGQWt5UWt5WlhjS25jTnFGVXJVbmpuY0I0MVpwaFR3ckxvaG9pdXRnYUtvZU1rcmw4cUsvMkRBbmltYXRpb25fYmcucG5nP3BzaWQ9MQ==.jpg"></p>
<h3>三、一个简单的2D动画</h3>
<p>有了上面的游戏素材，我们就来简单模拟一下植物大战僵尸中的一个场景。在下面的Demo中表现了两种运动：其一就是我们要控制22个小图片之间的切换，以此产生角色行动的动画（在原地）；其二就是控制图片切换的同时我们需要移动图片的位置从而形成角色在水平方向上行走动作。具体代码如下：</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>
</pre>
<p>1 using System;<br /> 2  using System.Collections.Generic;<br /> 3 using System.Linq;<br /> 4 using Microsoft.Xna.Framework;<br /> 5 using Microsoft.Xna.Framework.Audio;<br /> 6 using Microsoft.Xna.Framework.Content;<br /> 7 using Microsoft.Xna.Framework.GamerServices;<br /> 8 using Microsoft.Xna.Framework.Graphics;<br /> 9 using Microsoft.Xna.Framework.Input;<br />10 using Microsoft.Xna.Framework.Input.Touch;<br />11 using Microsoft.Xna.Framework.Media;<br />12 namespace _2DAnimation<br />13 {<br />14     public class MyGame : Microsoft.Xna.Framework.Game<br />15     {<br />16         GraphicsDeviceManager graphics;<br />17         SpriteBatch spriteBatch;<br />18         private Texture2D corpse;//图片资源<br />19         private Point frameSize;//每个小图片大小<br />20         private Point sheetSize;//小图片个数<br />21         private Point currentFrame;//当前小图片位置<br />22         private Vector2 postion;//角色所在位置<br />23         private float speed;//角色行走速度<br />24         private Texture2D background;<br />25         public MyGame()<br />26         {<br />27             graphics = new GraphicsDeviceManager(this);<br />28             Content.RootDirectory = "Content";<br />29             graphics.PreferredBackBufferWidth = 800;//设置游戏视窗大小<br />30             graphics.PreferredBackBufferHeight = 480;<br />31             TargetElapsedTime = TimeSpan.FromTicks(333333*2);<br />32         }<br />33         protected override void Initialize()<br />34         {<br />35             frameSize = new Point(100, 125);<br />36             sheetSize = new Point(11, 2);<br />37             currentFrame = new Point(0,0);<br />38             postion = new Vector2(graphics.PreferredBackBufferWidth-100,graphics.PreferredBackBufferHeight - 125-150);<br />39             speed = 3;<br />40             base.Initialize();<br />41         }<br />42         protected override void LoadContent()<br />43         {<br />44             spriteBatch = new SpriteBatch(GraphicsDevice);<br />45             background = this.Content.Load&lt;Texture2D&gt;("background");//加载游戏背景<br />46             corpse = this.Content.Load&lt;Texture2D&gt;("transparentCorpse");//加载整张大图片(透明背景)<br />47         }<br />48         protected override void UnloadContent()<br />49         {<br />50         }<br />51         protected override void Update(GameTime gameTime)<br />52         {<br />53             if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)<br />54                 this.Exit();<br />55             ++currentFrame.X;<br />56             if (currentFrame.X &gt;= sheetSize.X)<br />57             {<br />58                 currentFrame.X = 0;<br />59                 ++currentFrame.Y;<br />60                 if (currentFrame.Y &gt;= sheetSize.Y)<br />61                 {<br />62                     currentFrame.Y = 0;<br />63                 }<br />64             }<br />65             postion.X -= speed;<br />66             if (postion.X &lt; 20)<br />67             {<br />68                 this.Exit();//角色进入房屋后退出游戏<br />69             }<br />70             base.Update(gameTime);<br />71         }<br />72         protected override void Draw(GameTime gameTime)<br />73         {<br />74             GraphicsDevice.Clear(Color.CornflowerBlue);<br />75             spriteBatch.Begin(SpriteSortMode.BackToFront,BlendState.NonPremultiplied);//所有的绘制工作均在sprite的begin和end中间进行<br />76             spriteBatch.Draw(<br />77                 corpse,//要绘制的精灵<br />78                 postion,//绘制的位置<br />79                 new Rectangle(currentFrame.X * frameSize.X, currentFrame.Y * frameSize.Y, frameSize.X, frameSize.Y),//绘制精灵的哪一部分<br />80                 Color.White, //颜色<br />81                 0, //旋转角度<br />82                 Vector2.Zero,//旋转参考点 <br />83                 1, //缩放倍数<br />84                 SpriteEffects.None, //翻转<br />85                 0 //层深<br />86                 );<br />87             spriteBatch.Draw(background, Vector2.Zero, Color.White);<br />88             spriteBatch.End();<br />89             base.Draw(gameTime);<br />90         }<br />91     }<br />92 }</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>代码总体来说还是比较简单，主要通过在Update方法中动态修改currentFrame来形成图片切换，当然之所以这样是因为Draw方法的第三个参数，通过它我们才能做到一张图片的局部显示（具体来说就是在Rectangle中指定corpse精灵的起始坐标和要显示的图片宽度和高度）。图片的水平移动主要通过在Update中动态修改position变量的值，当然这里需要注意图片超出游戏视窗的情况。下面是运行效果：</p>
<p>截图效果：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvNzZ5MmRxLmJheS5saXZlZmlsZXN0b3JlLmNvbS95MXBzRk9fRGFHNE9tbVdZSExraEFqa0NjTUFUT0FVdldKVW9qRzhLekVFeDBvNWxEYWtWX3hGbF9TV1lMU25wOWRKRGJ3LW40V0hvcVR4Zmg0SVVFdm5qNEpZQjcwcGh5cWwvMkRBbmltYXRpb25fU2NyZWVuLnBuZz9wc2lkPTE=.jpg"></p>
<p>动画效果：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvNzZ5MmRxLmJheS5saXZlZmlsZXN0b3JlLmNvbS95MXBhbzJmYVVjWXlrWXplLVE4MXNwYlA4b0t2clFLelp2UGVRWTdOOHZ5cnYxeDdwZ05NZ3RSWEdTc1VnczNFSXlUU3RQa3Q0WHpQYjFhWm5WbERmVldTQ0laNGk0WlAzMTIvMkRBbmltYXRpb25fRHluaW1pYy5naWY/cHNpZD0x.jpg"></p>
<p>值得一提的是，我们这里牵扯到了图片显示的层深问题，如果注意看代码的朋友会发现我们并没有首先绘制游戏背景，而是先绘制了游戏角色（当然我是为了说明层深问题而故意这么做的）。默认情况下载XNA会按照程序调用顺序绘制精灵，这样我们就看不到角色了，因为它被背景图片遮住了。如果说遇到了这种情况（事实上游戏开发中经常遇到）我们就需要设置图片的层深，也就是我们上面代码中Draw方法的最后一个参数。它是float类型，其取值范围是0-1。具体0是代表最先绘制还是最后绘制则完全取决于SpriteBatch的Begin方法中的第一个参数，这个参数是SpriteSortMode，他是一个枚举类型，有五种模式：</p>
<table>
<tbody>
<tr>
<td>
<br /><strong>取值</strong></p>
</td>
<td>
<br /><strong>描述</strong></p>
</td>
</tr>
<tr>
<td>
<br /><strong>Deferred</strong></p>
</td>
<td>
<br />这是默认模式，此模式下只有在SpriteBatch调用End方法时才会被绘制，如果绘制多个精灵则按照调用次序依次进行。</p>
</td>
</tr>
<tr>
<td>
<br /><strong>Texture</strong></p>
</td>
<td>
<br />同Deferred类似，在绘制之前会按照纹理排序，对于相同深度而不互相重叠的情况下效果较好。</p>
</td>
</tr>
<tr>
<td>
<br /><strong>BackToFront</strong></p>
</td>
<td>
<br />在End方法执行后绘制精灵，绘制精灵的顺序按照层深度由前往后排序（先绘制层深值较小的）。</p>
</td>
</tr>
<tr>
<td>
<br /><strong>FrontToBack</strong></p>
</td>
<td>
<br />在End方法执行后绘制精灵，绘制精灵的顺序按照层深度由后往前排序（先绘制层深值较大的）。</p>
</td>
</tr>
<tr>
<td>
<br /><strong>Immediate</strong></p>
</td>
<td>
<br />调用Begin方法后就会立即绘制精灵(这也是五种模式中唯一在End方法之前就进行绘制的)，同一时间只有一个SpriteBatch被使用。</p>
</td>
</tr>
</tbody>
</table>
<p>另一点需要注意的是，我们的角色是透明的，在XNA Game开发中如果想要让图片透明有两种方式：第一就是图片本省就是透明，此时当然需要选用能够存储图像alpha的图片格式来保存图片（例如png格式可以将图像的alpha存储到图片信息中，我们上的例子中就是这么做的。事实上GIF也可以，但是在XNA中默认不支持GIF）；第二种方式就是将图片需要显示成透明的部分设置为洋红色（RGB：255,0,255），这样XNA会自动将洋红色部分渲染成透明。</p>
<p>OK,最后附上代码下载：</p>
<p><a href="http://cid-e7bd5e8882a6a2da.office.live.com/self.aspx/BlogFile/2DAnimation.zip" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcHVibGljLmJheS5saXZlZmlsZXN0b3JlLmNvbS95MXBiMWw0dEZSSmFnN1NPcDhzcDk2VXBVWU5yMFdFcmlWTDRXRy1UaV9GRTJleUxnQlhDV0lES1hONmFwMzJuYWhsb3AzRFFzaUJHdm8zcFRtM1p5dXRlZy9kb3dubG9hZC5wbmc/cHNpZD0x.jpg"></a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 04:24:53</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/windows/" title="windows">windows</a>, <a href="https://www.iamivan.net/tag/%e7%b2%be%e7%81%b5/" title="精灵">精灵</a>, <a href="https://www.iamivan.net/tag/%e9%80%8f%e6%98%8e/" title="透明">透明</a>, <a href="https://www.iamivan.net/tag/phone/" title="phone">phone</a>, <a href="https://www.iamivan.net/tag/xna/" title="xna">xna</a>, <a href="https://www.iamivan.net/tag/2d%e6%b8%b8%e6%88%8f/" title="2D游戏">2D游戏</a>, <a href="https://www.iamivan.net/tag/%e5%b1%82%e6%b7%b1/" title="层深">层深</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>XNA游戏开发之2D游戏的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvrB4NM.html" rel="bookmark">安卓游戏-开发安卓2D游戏用AndEngine好还是JBOX2D好？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 开发安卓2D游戏用AndEngine好还是JBOX2D好? 全靠兴趣自学JAVA和安卓没多久,现在准备跟同学一块做2D游戏,我们想用引擎开发,请问用AndEngine好还是单纯的用JBOX2D好,这两个都学了一些,哪个适合初学者呢? 解决方案 JBOX2D没用过,AndEngine挺不错的,虽然文档少,但是有官方的demo,还有一本书叫andengine cook book,看完之后就基本上手了 http://ygydaiaq-gmail-com.iteye.com/blog/1843			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV7J4Qb.html" rel="bookmark">Android 游戏开发之Canvas画布的介绍及方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Canvas,在英语中,这个单词的意思是帆布.在Android中,则把Canvas当做画布,只要我们借助设置好的画笔(Paint类)就可以在画布上绘制我们想要的任何东西:另外它也是显示位图(Bitmap类)的核心类.随用户的喜好,Canvas还可设置一些关于画布的属性,比如,画布的颜色.尺寸等.Canvas提供了如下一些方法:    Canvas(): 创建一个空的画布,可以使用setBitmap()方法来设置绘制具体的画布.    Canvas(Bitmap bitmap): 以bitmap对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBRdxJb.html" rel="bookmark">3D网游中国叫好不叫座：游戏公司抢夺2D市场</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2D网游在中国的红火显现了它在这块土地上的顽强生命力. 时下,2D网游的影子在很多国家和地区已经几近绝迹,但是在中国,2D网游仍然具备顽强的生命力.虽然国内游戏行业正在努力向3D市场过渡,但是2D游戏的影响力似乎并没有被削弱.在几次激进的尝试后,2D游戏如今已经成为网游大佬们在2010年的新王牌,2D网游在中国将继续完成它尚未完成的历史使命. 市场回暖 新年一到,多家游戏公司宣布在2010年将推出2D类游戏,而这其中包括以研发3D起家的完美时空.新科行业状元腾讯以及第三代游戏公司的代表蓝港在线.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEgvDJp.html" rel="bookmark">CocosSharp &mdash;&mdash; C&num; 版本的 2D 游戏开发引擎</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				CocosSharp 是一个用 C# 来开发跨平台 2D 游戏的游戏开发包.如果你熟悉 Cocos2D 的话,那么你会很快上手 CocosSharp,API 的设计遵循 C# 和 .NET 规范.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baKWJ2p.html" rel="bookmark">Strive 2D游戏引擎 －－ 序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				     利用业余时间写了个基于XNA 3.0 的2D网络游戏引擎,引擎取名为Strive -- 奋斗.      基于Strive引擎,我做了个Demo - XTank,本文末会提供XTank的源码下载.下图是XTank游戏的截图:                 1.操作键说明:      数字键:1 - 创建PC :2 - 创建敌人 :3 - 创建树木      方向键:A.S.D.W      射  击:J         2.开发环境:VS2008 + XNA Studio 3.0  			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/aM6xeLz.html" rel="bookmark">HTML 5 2D 游戏开发：Sprites</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				和其他艺术形式(比如电影.戏剧和小说)一样,游戏也有一系列的人物,每个人物都扮演着特定的角色 .例如,Snail Bait 有跑步小人(游戏主角).硬币.红宝石.蓝宝石.蜜蜂.蝙蝠.纽扣和一个蜗牛,图 1 中展示了其中的大多数角色.在本系列的第 1 篇文章中(参阅 sprite:演员表 小节),已经介绍了这些 人物以及它们在游戏中的角色. 图 1. Snail Bait 的人物 开发:Sprites-html5 2d游戏引擎&quot;&gt; Snail Bait 中每个人物都是一 个 sprite.S			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/2MWnXAb.html" rel="bookmark">HTML 5 2D 游戏开发：设置舞台</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				游戏开发的许多方面都和玩游戏没有关系.显示说明.暂停游戏.级别之间的过渡和滚动游戏分数,这些 都是游戏开发人员必须在游戏本身以外实现的一些特性. 当游戏的灵感来临时,这些灵感中通常不包 括显示高分数或级别之间的过渡的巧妙方式,开发人员会很自然地深入研究如何实现游戏机制,但对于游戏的 基础架构却没有太多的想法.但在大多数项目中,如果想在开发后添加功能,所需的工作量比从一开始就添加 功能要大得多. 在本系列的 上一期文章 中,我讨论了图形和动画,这些是 Snail Bait 游戏的基础 内容.在本文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VzwYLEM.html" rel="bookmark">HTML 5 2D 游戏开发：图形和动画</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				图形和动画是任何视频游戏最根本的方面,所以在本文中,我将从 Canvas2D API 的简要介绍开始,对 Snail Bait 的中央动画的实现进行讨论.在本文中,您将学习如何: 将图像和图形基元绘制到画布上 创建流畅的.无闪烁的动画 实现游戏循环 以帧数每秒为单位监视动画的速度 滚动游戏的背景 使用视差来模拟三维效果 实现基于时间的运动 本文中所讨论的代码的最终结果如图 1 所示: 图 1. 滚动背景并监视帧速率 开发:图形和动画-html5 2d游戏引擎&quot;&gt; 背景和平台水平 滚动.这些			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0QVk7p.html" rel="bookmark">《HTML5 2D游戏编程核心技术》&mdash;&mdash;第1章，第1&period;1节Snail Bait游戏</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本节书摘来自华章出版社&lt;HTML5 2D游戏编程核心技术&gt;一书中的第1章,第1.1节,作者［美］ 戴维·吉尔里,更多章节内容可以访问&quot;华章计算机&quot;公众号查看. 第1章 概 述 令人激动的是,开发人员可以使用软件开发技术使屏幕上出现任何想象的场景.与其他领域受一些物理条件的束缚不同,开发人员长期以来一直使用图形化API和UI工具包来实现富有创造性且引人注目的应用程序.可以说,最有创意的软件开发就是游戏编程.比起让游戏愿景变成现实,优秀的创意还可使我们通过少许努力便获得更多的回			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6G3Yp.html" rel="bookmark" class="title">如何在工具栏上添加平面下拉控件</a>
					<div>
						效果图如下: 使用过WordXP的人都知道,她的界面可谓是耳目一新.尤其是她的菜单和工具条可真是酷.网上也有很多很多的人都在模仿着她,包括很多的软件公司的产品.她的出现,使得软件界刮起了一陈XP界面时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWxPAp.html" rel="bookmark" class="title">学习：如何在HTML中引用XML数据</a>
					<div>
						xml|数据 1,内嵌XML数据&lt;html&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Content-Type&quot; content=&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgDE5p.html" rel="bookmark" class="title">如何管理CSS</a>
					<div>
						css  CSS注释代码来自:www.kurier.at 处看到觉得挺有意思的,而后就发现这种注释体现了这会设计师的智慧阿!呵呵他按照功能把css书写顺序标注的很清晰,每个类别控制的范围也注明了.下面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqKm2z.html" rel="bookmark" class="title">ASP&period;NET&plus;MySQL简明图示入门</a>
					<div>
						asp.net|mysql 在ASP时代,如果我们要建立一个数据库驱动的web站点,那么你可以选择环很多钱的微软SQL SERVER数据库或者选择要花很多时间来寻找达到性能和稳定性统一的ACCESS数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnx7OKb.html" rel="bookmark" class="title">Nexsan的绿色数据存储方案</a>
					<div>
						数据中心已成为很多公司的最大能源消耗中心,如何降低能耗,如何提高利用效率,如何减少运营成本?这些基于环保节能的考虑,使绿色存储成为近年新兴的一个概念,一个新的主题. Gartner认为,到了2008年 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlxn5b.html" rel="bookmark" class="title">cisco交换机常用命令</a>
					<div>
						交换机命令 switch&gt; 用户模式 1:进入特权模式 enable switch&gt; enable switch# 2:进入全局配置模式 configure terminal switch ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62Q2WM.html" rel="bookmark" class="title">用JAX-RPC构建RPC服务和客户机&colon;使用Java API构建基于RPC的Web服务&lpar;一&rpar;</a>
					<div>
						简介:远程过程调用(RPC)是基于 Simple Object Access Protocol(SOAP)或 Representational State Transfer(REST)的现代 Web  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKLgap.html" rel="bookmark" class="title">ASP&period;NET MVC2右键菜单和最简单分页</a>
					<div>
						右键菜单非常方便,很多时候会用到.这篇文章将使用一个JQUERY的插件在 asp.net mvc中实现右键菜单.本文还将介绍一下在asp.net mvc中如何实现简单 的分页.效果如下图: 首先,下载 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKgQ3M.html" rel="bookmark" class="title">JUnit反模式</a>
					<div>
						JUnit 的出现为开发人员带来了福音.遗憾的是,许多人仍然认为学会 JUnit API,编写几个测试,最后得到一个测试良好的应用程序就足够了.这种想法比不进行任何测试还要糟,因为这会导致对代码健康状 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8krKb.html" rel="bookmark" class="title">url-xml解析，怎么保留特殊字符</a>
					<div>
						问题描述 xml解析,怎么保留特殊字符 xml文件中有一条数据: &lt;data key=&quot;&quot;url&quot;&quot; value=&quot;&quot;XXX.com/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badyYqz.html" rel="bookmark" class="title">java-word文档、excel文档等office软件转换成swf格式，不要安装任何东西的</a>
					<div>
						问题描述 word文档.excel文档等office软件转换成swf格式,不要安装任何东西的 我用的是FlexPaper来在线阅读文档,可是要转换成swf文件 解决方案 你这个不太可能实现啊.转换都是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGA22EM.html" rel="bookmark" class="title">Python实现竖排打印传单手机号码易撕条&lowbar;python</a>
					<div>
						使用python 2.7,初学,代码比较简单. numPrinter.py 复制代码 代码如下: #!/usr/bin/env python # -*- coding: utf-8 -*- '''   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2P4nkp.html" rel="bookmark" class="title">把asp程序封装成可执行文件（无需IIS web服务器）直接运行的管理系统</a>
					<div>
						该系统采用ASP网页编程技术.SCRIPT脚本编程技术与远程数据库有机结合,实现了远程数据库的维护管理.一个单位只需运行在一台计算机上(建议使用win2000或winXP以上操作系统),其他用户只要通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN77Zmp.html" rel="bookmark" class="title">验证码-大侠，mob短信验证求助，一点击这个页面APP就崩溃</a>
					<div>
						问题描述 大侠,mob短信验证求助,一点击这个页面APP就崩溃 import android.app.Activity; import cn.smssdk.EventHandler; import c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6qkqz.html" rel="bookmark" class="title">PHP 中的Closure</a>
					<div>
						PHP 中的Closure Closure,匿名函数,又称为Anonymous functions,是php5.3的时候引入的.匿名函数就是没有定义名字的函数.这点牢牢记住就能理解匿名函数的定义了.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QjZDp.html" rel="bookmark" class="title">网络二层通信 raw socket</a>
					<div>
						问题描述 网络二层通信 raw socket 两主机使用二层通信.两主机均有一个物理接口ethlan,一个逻辑接口br0,ethlan同时均在桥在 br0下且br0均使用ethlan的mac地址.当发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrAQQM.html" rel="bookmark" class="title">保留小数点后两位-关于Java的BigDecimal类处理小数点的问题</a>
					<div>
						问题描述 关于Java的BigDecimal类处理小数点的问题 double C = a + b + c; return new BigDecimal(C).setScale(2, BigDecima ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba73vXp.html" rel="bookmark" class="title">超越用户预期</a>
					<div>
						DB表(化名),源自瑞士品牌,在瑞士注册,由香港某明星代言,定位中高端,线下主攻商场和专柜.线下销售较成熟,老板从事钟表行业十几年. 去年开设天猫旗舰店,电子商务团队约6人,产品在天猫售价300-13 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqR9nGp.html" rel="bookmark" class="title">java-JAVA程序设计基础篇第八版编程题答案</a>
					<div>
						问题描述 JAVA程序设计基础篇第八版编程题答案 有没有JAVA语言程序设计基础篇第八版的编程题的的答案!!!李娜翻译的					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqR4mkp.html" rel="bookmark" class="title">又遇新问题&colon;怎么不自动读取文章了&quest;</a>
					<div>
						问题描述 刚才突然发现,我的显示页,只显示第一条记录.昨天做了一个页,显示正常,今天也是按昨天的方法做,不知道怎么就不行了.总是显示第一篇文章,但数据库里面又增加了新的内容. 解决方案 解决方案二:把 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0qwAp.html" rel="bookmark" class="title">样式-页面两个标签内容重叠，怎么动态增加div高度</a>
					<div>
						问题描述 页面两个标签内容重叠,怎么动态增加div高度 动态在div中加载图片,覆盖下面的内容,怎么办?是改变css样式,还是用js动态调整高度? 解决方案 不要定高,定高如果内容增加就导致和下面的内 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjw180M.html" rel="bookmark" class="title">java-pl&sol;sql developer查询问题</a>
					<div>
						问题描述 pl/sql developer查询问题 我用sql窗口和command窗口查询同一个表,结果不一样啊.这是为什么? 解决方案 http://bbs.csdn.net/topics/3907 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0ndN0z.html" rel="bookmark" class="title">rho 1&period;1&period;06发布 小型文本编辑器</a>
					<div>
						rho 1.1.06该版本bind.get_binding函数更名为exist_binding,并一个新的get_binding创建扫描绑定表中的四个不同的函数.Bind.new_binding从bi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeQ5PM.html" rel="bookmark" class="title">新浪宕机暴露开放平台下的潜在危机</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 12月1日上午10时,新浪微博突然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/MyeBVEM.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcmVhZC5odG1sNS5xcS5jb20vaW1hZ2U/c3JjPWZvcnVtJmFtcDtxPTUmYW1wO3I9MCZhbXA7aW1nZmxhZz03JmFtcDtpbWFnZVVybD1odHRwOi8vZXNzYXkuYjAudXBhaXl1bi5jb20vMTc0Ny8zNjc0MzUvMC5qcGc=.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/MyeBVEM.html" rel="bookmark" class="title">数据挖掘在电子商务的应用：如何选择商品关键词</a>
					<div>
						对平台上的卖家来说,如何给宝贝取标题.选择关键词投放对于获取站内站外的搜索流量来说都至关重要,而对于独立B2C来说,在显示搜索结果时,除了根据商品关键词进行匹配外,还可以向用户主动推荐关联商品. 在选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Y4DVz.html" rel="bookmark" class="title">百日创业板迎来成长烦恼</a>
					<div>
						去年10月30日中国创业板开市钟声敲响,28只新股集中上市交易.如今创业板已度过百日,经过初期的市场热情追捧和投机爆炒后,现在逐渐趋于理性.同时,创业板也迎来了成长的烦恼,最近一段时间它被扩容.破发. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7lPXM.html" rel="bookmark" class="title">php利用正则过滤链接、标签，空格，换行符程序</a>
					<div>
						strip_tags函数 strip_tags --- 去除字串中的HTML和PHP标签 语法 : string strip_tags (string str [, string allowable_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVjjaz.html" rel="bookmark" class="title">Ubuntu Server 安装和使用 Elasticsearch 搜索引擎</a>
					<div>
						我们建立一个网站或应用程序,并要添加搜索功能,令我们受打击的是:搜索工作是很难的.我们希望我们的搜索解决方案要快,我们希望有一个零配置和一个完全免费的搜索模式,我们希望能够简单地使用JSON通过HTT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mlm1Gnp.html" rel="bookmark" class="title">SqlConnection 的连接池机制解析</a>
					<div>
						物理连接建立时,需要做和服务器握手,解析连接字符串,授权,约束的检查等等操作,而物理连接建立后,这些操作就不会去做了.这些操作是需要一定的时间的.所以很多人喜欢用一个静态对象存储 SqlConnect ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1ZBab.html" rel="bookmark" class="title">jquery表单验证插件用法与实例</a>
					<div>
						&lt;!doctype html public &quot;-//w3c//dtd xhtml 1.0 transitional//en&quot; &quot;http://www.w3.org/ ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
